#include "RROScommands.bas"
gosub InitRROScommands

stepping off
/**************************************************************************
* Normally, you would #include the InitializationRoutines.bas file here *
* and then call the appropriate routine for your robot. The standard *
* RB-9 init routine does not include the compass (because it would cause *
* the program to 'hang' if no compass is pressent. Rather than change *
* that standard routine, this program includes a copy of the RB-9 init *
* routine with the compass included. It is suggested that you modify *
* the initialization routines you use so they match your specific *
* hardware. *
* *
* This program rotates the robot until it finds a large object. When one *
* is found, the robot moves to it. *
**************************************************************************/
MainProgram:
REAL=true // change to true if a real robot is being used
gosub Init
 // go to object
E=0
Q=32
H=64
W=128
D=224


main:
     rLocate 350,300
     rInvisible Green
     rPen down     
     Stopped=10

mainLoop:
    Joystick 2,x,y,z,b
      
    if b=1 then gosub Home
      
    x=(round(x*360)-180)
    if x<Stopped and x>(Stopped*-1) then x=0
    y=(round(y*512)-255)*-1
    if y<Stopped and y>(Stopped*-1) then y=0
      
    radius=y/64
    angle=x/36

    if REAL=true
        s=abs(y)
        //if abs(x)>s then s=abs(x)        
        xystring 10,50,"Speed ",s,spaces(2)    
        rSpeed 255-s
    endif     

    if y=0
       xystring 10,10,"Neutral  "
    elseif y<0
       xystring 10,10,"Backward "
    else   
       xystring 10,10,"Forward  "
    endif

    if angle=0
       xystring -1,-1,spaces(6)
    elseif angle<0
       xystring -1,-1,"Left "
    else   
       xystring -1,-1,"Right"
    endif 
    
    battery=rChargeLevel()
    xystring 10,30,"Battery Charge =",battery,"   "                                                            

    if y<0
        FB=128
    else
        FB=0
    endif
                      
    if x<0
        RL=64
    else
        RL=0
    endif
    
    Percent=100-(abs(x)*300/180)
    if Percent<0 then Percent=0
    xystring 10,70,"Percent =",Percent,"   "
    
    gosub Chk4Danger
                                  
    gosub ArcTurn

    goto mainLoop
end

Home:
    CState=0
    rCommand(210,0)
    while CState=0   
        response=rCommand(210,1)
        CState=ascii(Substring(response,5,1))
        xystring 10,90,"Charging State=",HEX (CState),spaces(5)
        response=rCommand(210,2)
        IOMode=ascii(Substring(response,5,1))         
        xystring 10,110,"IO Mode=",HEX (IOMode),spaces(5)                
    wend
    clearscr
    rLocate 350,300      
    return
    
Chk4Danger:
    //xystring 10,90,"Bump=",rBumper()," rFeel=",rFeel(),spaces(6)
    if rBumper()<>0 or rFeel()<>0
       if (rBumper() & 0%00001010) = 0%00001010
          rCommand(131,67)                // PlaySound    
       elseif (rBumper() & 0%00000010) = 0%00000010
          rCommand(131,65)                // PlaySound
       elseif (rBumper() & 0%00001000) = 0%00001000
          rCommand(131,66)                // PlaySound
       endif
       if (rFeel() & 0%00000001) = 0%00000001 then rCommand(131,68)                // PlaySound
       rSpeed 0
       rTurn 180              
    endif
    rSpeed 255-s
    return
    
ArcTurn:
    if REAL=true
        rCommand(159,FB+RL+(Percent/2))
    else
        rForward radius
        if radius<0 then newangle=angle*-1
        rTurn newangle
    endif
    return
    
Init:
     if REAL
        gosub InitRB9robot // use a routine for your robot (or modify this one)
     else
        gosub DrawObjects
        // init the simulator
        rlocate 400,300,random(360)
        rSpeed 10
     endif
return

DrawObjects:
     Linewidth 10
     SetColor Blue
     Line 300,340,250,250
     circlewh 400,400,10,10
     circlewh 500,300,30,30
     Line 600,500,700,450
return

InitRB9robot:
// modify everything as necessary to match your hardware
//rCommport 66 //change to the virtual port used for your Bluetooth device
rCommport 28 //change to the virtual port used for your Serial device
SetTimeOut 5000
delay 1000
return
