' USB sample program for PIC18F4550 CDC serial port emulation
'  Requires PBP 2.60 or later

'  Compilation of this program requires that specific support files be
'  available in the source directory.  For detailed information, see
'  the file PBP\USB18\USB.TXT.


	
	Include	"cdc_desc.bas"	' Include the HID descriptors

#CONFIG
	CONFIG  PLLDIV = 3			; 12MHz input
    CONFIG  DEBUG = ON           ; Enabled	
#ENDCONFIG

Define  OSC     48

buffer	Var	Byte[16]
cnt	Var	Byte


	OSCTUNE.6 = 1		' Enable PLL for 18F87J50 family
	Pause 10

	USBInit			' Get USB going

' Wait for USB input
idleloop:
	USBService		' Must service USB regularly
	cnt = 16		' Specify input buffer size
	USBIn 3, buffer, cnt, idleloop

' Message received
	buffer[0] = "H"
	buffer[1] = "e"
	buffer[2] = "l"
	buffer[3] = "l"
	buffer[4] = "o"
	buffer[5] = " "
	buffer[6] = "W"
	buffer[7] = "o"
	buffer[8] = "r"
	buffer[9] = "l"
	buffer[10] = "d"
	buffer[11] = 13
	buffer[12] = 10
	buffer[13] = 0

outloop:
	USBService		' Must service USB regularly
	USBOut 3, buffer, 14, outloop

	Goto idleloop		' Wait for next buffer
